import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertArrayEquals;

public class Aufgabe1Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Test
    public void testInsertMutatingSize5General() throws Exception {

        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        Aufgabe1.insertMutating(array,toInsert,2);
        int[] expected = new int[]{15,12,2,3,10};
        assertArrayEquals(expected, array);

    }

    @Test
    public void testInsertMutatingSize5FirstStart() throws Exception {

        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        Aufgabe1.insertMutating(array,toInsert,0);
        int[] expected = new int[]{2,3,15,12,10};
        assertArrayEquals(expected, array);

    }

    @Test
    public void testInsertMutatingSize5End() throws Exception {

        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        Aufgabe1.insertMutating(array,toInsert,3);
        int[] expected = new int[]{15,12,10,2,3};
        assertArrayEquals(expected, array);

    }

    @Test
    public void testInsertMutatingSize5NoFit() throws Exception {

        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        Aufgabe1.insertMutating(array,toInsert,4);
        int[] expected = new int[]{15,12,10,14,2};
        assertArrayEquals(expected, array);

    }

    @Test
    public void testInsertSize5() throws Exception {

        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        array = Aufgabe1.insert(array,toInsert,2);
        int[] expected = new int[]{15,12,2,3,10,14,17};
        assertArrayEquals(expected, array);

    }

    @Test
    public void testInsertSize5Start() throws Exception {

        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        array = Aufgabe1.insert(array,toInsert,0);
        int[] expected = new int[]{2,3,15,12,10,14,17};
        assertArrayEquals(expected, array);

    }

}