public class Aufgabe2 {

    /*
    Aufgabe:
        Methoden zur Manipulation eines zwei-dimensionalen Arrays, interpretiert
        als Matrix (mit Zeilen und Spalten).
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt.

    Punkte (maximal 20):
        10 Punkte für 'bargraph',
        10 Punkte für 'reshape'.
    */

    // Erzeugt aus 'data' ein Balkendiagramm, d.h. ein mehrdimensionales Array
    // in dem jedes Array der zweiten Ebene einen Balken darstellt, dessen Länge
    // dem Wert data[i] entspricht. Die Anzahl der Balken wird durch die Länge
    // von 'data' vorgegeben. Zusätzlich wird in jeder Zeile ein Zeichen dem Balken
    // vorangestellt, das den Index in 'data' angibt:
    // 'A' steht für den Index i == 0, 'B' für i == 1, etc.
    // Beachten Sie die Beispiele in der Methode 'main'.
    // Vorbedingung: 'data' ist nicht null und enthält nur Einträge >= 0.
    public static char[][] bargraph(int[] data) {
        // TODO: implementieren Sie die Methode.

        char[][] result = new char[data.length][];
        char c = 'A';

        for (int i = 0; i < result.length; i++) {
            char[] line = new char[data[i] + 1];


            if (data[i] != 0) {
                for (int j = 0; j < data[i]+1; j++) {
                    if (j == 0) {
                        line[j] = c;
                    } else {
                        line[j] = '#';
                    }

                }
            } else {
                line[0] = c;
            }
            c++;

            result[i] = line;
        }
        return result;

    }

    // Liefert ein neues Array mit dem gleichen Inhalt wie 'bargraph',
    // jedoch zu einer rechteckigen Form erweitert, d.h. alle Zeilen
    // des zurückgelieferten Arrays sind gleich lang, nämlich solange
    // wie die maximale Zeilenlänge im ursprünglichen Array.
    // Aufgefüllt wird mit dem Zeichen '.'.
    // HINWEIS: Sie können diese Methode auch dann implementieren, wenn Sie
    // die Methode 'bargraph' nicht implementiert haben.
    // Vorbedingung: bargraph != null und bargraph.length > 0
    public static char[][] reshape(char[][] bargraph) {
        //TODO: Implementieren Sie diese Methode

        int rowSize = 0;
        for (int i = 0; i < bargraph.length; i++) {
            if (bargraph[i].length > rowSize) {
                rowSize = bargraph[i].length;
            }
        }

        char[][] result = new char[bargraph.length][rowSize];

        for (int i = 0; i < result.length; i++) {
            for (int j = 0; j < result[i].length; j++) {
                if (j < bargraph[i].length) {
                    result[i][j] = bargraph[i][j];
                } else {
                    result[i][j] = '.';
                }
            }
        }

        return result; // TODO: entfernen Sie diese Zeile.

    }

    // Gibt das angegebene Array zeilenweise aus.
    // Der Zeilenindex erhöht sich von unten nach oben.
    // Der Spaltenindex erhöht sich von links nach rechts.
    // Vorbedingung: array != null und alle array[i] != null (0 <= i < array.length)
    // DIESE METHODE SOLL NICHT VERÄNDERT WERDEN.
    public static void printMultiArray(char[][] array) {
        for (int i = array.length - 1; i >= 0; i--) {
            for (int j = 0; j < array[i].length; j++) {
                System.out.print(array[i][j] + "\t");
            }
            System.out.println();
        }

    }

    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        //Testen von 'bargraph':
        printMultiArray(bargraph(new int[]{1,3,5,4,2,0,1,0}));
        // H
        // G  #
        // F
        // E  #  #
        // D  #  #  #  #
        // C  #  #  #  #  #
        // B  #  #  #
        // A  #


        System.out.println();

        //Testen von 'reshape':
        //Falls die Methode 'bargraph' nicht implementiert wurde,
        //wird hier zunächst ein Array erzeugt.
        char[][] bargraph = new char[8][];
        bargraph[7] = new char[] {'H'};
        bargraph[6] = new char[] {'G', '#'};
        bargraph[5] = new char[] {'F'};
        bargraph[4] = new char[] {'E','#','#'};
        bargraph[3] = new char[] {'D','#','#','#','#'};
        bargraph[2] = new char[] {'C','#','#','#','#','#'};
        bargraph[1] = new char[] {'B','#','#','#'};
        bargraph[0] = new char[] {'A','#'};

        bargraph = reshape(bargraph);
        printMultiArray(bargraph);
        // H  .  .  .  .  .
        // G  #  .  .  .  .
        // F  .  .  .  .  .
        // E  #  #  .  .  .
        // D  #  #  #  #  .
        // C  #  #  #  #  #
        // B  #  #  #  .  .
        // A  #  .  .  .  .


    }

}

