import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Test
    public void testBargraphGeneral() throws Exception {
        char[][] expectedResult = new char[8][];
        expectedResult[7] = new char[] {'H'};
        expectedResult[6] = new char[] {'G', '#'};
        expectedResult[5] = new char[] {'F'};
        expectedResult[4] = new char[] {'E','#','#'};
        expectedResult[3] = new char[] {'D','#','#','#','#'};
        expectedResult[2] = new char[] {'C','#','#','#','#','#'};
        expectedResult[1] = new char[] {'B','#','#','#'};
        expectedResult[0] = new char[] {'A','#'};
        char[][] result = Aufgabe2.bargraph(new int[]{1,3,5,4,2,0,1,0});
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testBargraphOneColumn1() throws Exception {
        char[][] expectedResult = new char[1][];
        expectedResult[0] = new char[] {'A'};
        char[][] result = Aufgabe2.bargraph(new int[]{0});
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testBargraphOneColumn2() throws Exception {
        char[][] expectedResult = new char[1][];
        expectedResult[0] = new char[] {'A','#'};
        char[][] result = Aufgabe2.bargraph(new int[]{1});
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testAxisGeneral1() throws Exception {
        char[][] input = new char[8][];
        input[7] = new char[] {'H'};
        input[6] = new char[] {'G', '#'};
        input[5] = new char[] {'F'};
        input[4] = new char[] {'E','#','#'};
        input[3] = new char[] {'D','#','#','#','#'};
        input[2] = new char[] {'C','#','#','#','#','#'};
        input[1] = new char[] {'B','#','#','#'};
        input[0] = new char[] {'A','#'};
        char[][] result = Aufgabe2.reshape(input);
        char[][] expectedResult = new char[8][6];
        expectedResult[7] = new char[] {'H','.','.','.','.','.'};
        expectedResult[6] = new char[] {'G','#','.','.','.','.'};
        expectedResult[5] = new char[] {'F','.','.','.','.','.'};
        expectedResult[4] = new char[] {'E','#','#','.','.','.'};
        expectedResult[3] = new char[] {'D','#','#','#','#','.'};
        expectedResult[2] = new char[] {'C','#','#','#','#','#'};
        expectedResult[1] = new char[] {'B','#','#','#','.','.'};
        expectedResult[0] = new char[] {'A','#','.','.','.','.'};
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testAxisGeneral2() throws Exception {
        char[][] input = new char[3][];
        input[2] = new char[] {'C','#','#'};
        input[1] = new char[] {'B','#','#'};
        input[0] = new char[] {'A','#','#'};
        char[][] result = Aufgabe2.reshape(input);
        char[][] expectedResult = new char[3][];
        expectedResult[2] = new char[] {'C','#','#'};
        expectedResult[1] = new char[] {'B','#','#'};
        expectedResult[0] = new char[] {'A','#','#'};
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testAxisOneColumn() throws Exception {
        char[][] input = new char[3][1];
        input[2] = new char[] {'#'};
        input[1] = new char[] {'#'};
        input[0] = new char[] {'#'};
        char[][] result = Aufgabe2.reshape(input);
        char[][] expectedResult = new char[3][1];
        expectedResult[2] = new char[] {'#'};
        expectedResult[1] = new char[] {'#'};
        expectedResult[0] = new char[] {'#'};
        Assert.assertArrayEquals(expectedResult, result);
    }

}