import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertThat;

public class Aufgabe3Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    // Gibt alle Ziffern von n in umgekehrter Reihenfolge aus.
    // Die Ausgabe wird mit einem '.' abgeschlossen.
    // Vorbedingung: n >= 0.
    public static void printDigits(int n) {
        do {
            System.out.print(n % 10);
            n /= 10;
        } while (n > 0);
        System.out.println(".");
    }

    // Vorbedingung: k != 0
    public static int f(int n, int k) {
        return n < 0 ? f(-2*n,k) : n/(2*k);
    }


    @Test
    public void testPalindromePK() throws Exception {
                Assert.assertThat(Aufgabe3.palindrom(new char[] {'P','K'}),
                        is(false));

    }

    @Test
    public void testPalindromeANA() throws Exception {
        Assert.assertThat(Aufgabe3.palindrom(new char[] {'A','N','A'}),
                is(true));

    }

    @Test
    public void testPalindromeANNA() throws Exception {
        Assert.assertThat(Aufgabe3.palindrom(new char[] {'A','N','N','A'}),
                is(true));

    }

    @Test
    public void testPalindromeA() throws Exception {
        Assert.assertThat(Aufgabe3.palindrom(new char[] {'A'}),
                is(true));

    }

    @Test
    public void testF() throws Exception {
        for(int n = -10; n <= 10; n++) {
            for(int k = -10; k <= 10; k++) {
                if (k == 0) continue;
                Assert.assertThat(Aufgabe3.f(n,k), is(Aufgabe3Test.f(n,k)));
            }
        }

    }

    @Test
    public void testPrintDigits255() throws Exception {
        int input = 123;
        Aufgabe3.printDigits(input);
        assertEquals("321.", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintDigits1() throws Exception {
        int input = 1;
        Aufgabe3.printDigits(input);
        assertEquals("1.", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintDigits10() throws Exception {
        int input = 10;
        Aufgabe3.printDigits(input);
        assertEquals("01.", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintDigits1000() throws Exception {
        int input = 1000;
        Aufgabe3.printDigits(input);
        assertEquals("0001.", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintDigits0To500() throws Exception {
        for(int input = 0; input < 500; input++) {
            Aufgabe3.printDigits(input);
            String result = log.getLog().trim();
            log.clear();
            Aufgabe3Test.printDigits(input);
            String expected = log.getLog().trim();
            assertThat(expected, is(result));
            log.clear();
        }
    }


}